/*********************************************
(c) 1999-2003 Die Informationsgesellschaft mbH
www.informationsgesellschaft.com
*********************************************/

var _aMs = []; // Array der Menebenen
var oToOpenMenu = null;

function BTextMenu (nLevel) {
	this.init = BMenu;
	this.init(nLevel);
	
/*
	Gibt die Breite des breitesten Elements (und damit der ganzen Ausklappebene) zurueck
*/
	this.getElementsWidth = function (nFontSize) {
		var nWidth = 0;
		for (var i=0; i<this.aElements.length; i++) 
			nWidth = Math.max(nWidth, this.getStringWidth (this.aElements[i][1], nFontSize));
		return (nWidth);
	};
	
/*
	Gibt die Breite eines Textes in Pixeln zurueck
*/
	this.getStringWidth = function (cText, nFontSize) {
		if (!nFontSize) nFontSize = 12;
		var nFontFactor = 56;
		if (nFontSize == 10 || nFontSize == 12) nFontFactor += 3;

		cText += '';
		cText = cText.replace(/\&[a-z]+\;/gi,"x");
		var nWidth = cText.length * 100;
		var aHits = cText.match (/[ filrtI\(\)\|\/\'\\!\:"]/g);
		if (aHits) nWidth -= (aHits.length * 56);
		var aHits = cText.match (/[ABCDEFGHKMNOPQRSTUWXYZwm@]/g);
		if (aHits) nWidth += (aHits.length * 57);
		nWidth = nWidth * nFontSize * nFontFactor / 10000;
		return (Math.round(nWidth));
	}

}

function BMenu (nLevel) {
	if (!this.aPos) this.aPos = [110, 10]; 				// die Ausgangsposition der ersten Menebene [Breite, Hoehe]
	this.nLevel = (nLevel > 0 ? nLevel : 0); // Menebene (0-basiert)
	_aMs[this.nLevel] = this; 		// Array der Menebenen
	this.nChildOffset = 0; 				// bestimmt den Abstand zwischen den Ebenen
	this.nWidth = 100;						// Standardbreite einer Menebene
	this.nHigh = null;
	this.nSelected = null;
	this.nPreSelected = null;
	this.nElementsWidth = 100;		// Standardbreite eines Elements
	this.nElementHeight = 20; 		// die Standardhoehe eines Elements
	this.oParent = null;					
	this.oChild = null;
	this.bFolded = null;
	this.oToUpdateChild = null;
	if (this.nLevel == 0) {
		this.oToOpen = null;
		this.oToClose = null;
	} 

	// aLayers = [MenuBg, MenuText, MenuMo]
	this.aLayers = [getLayer('MenuBg' + this.nLevel)];
	if (this.aLayers[0]) {
		this.aLayers[1]	= getLayer('MenuFg' + this.nLevel);
		if (!this.aLayers[1]) alert ('Layer MenuFg' + this.nLevel + ' not found');
		this.aLayers[2]	= getLayer('MenuMo' + this.nLevel);
		if (!this.aLayers[2]) alert ('Layer MenuMo' + this.nLevel + ' not found');
		if (getLayer('MenuBg' + (this.nLevel+1))) {
			this.oChild = new Menu (this.nLevel+1);
			this.oChild.oParent = this;
		}
	}
	else
		alert ('Layer MenuBg' + this.nLevel + ' not found');
	
	for (var i=0; i<this.aLayers.length; i++) this.aLayers[i].moveTo (this.aPos[0], this.aPos[1]);
	
	this.getBgContent	= function () { return (this.getContent(0)); }
	this.getFgContent = function () { return (this.getContent(1)); }
	this.getMoContent	= function () { return (this.getContent(2)); }

	this.setChildConnector = function() {};
	
	
/*
	Bestimmt die Position des aktuellen Mens
*/	
	this.getPosition = function () {
		var aPos = [_aMs[0].aPos[0], _aMs[0].aPos[1]];
		if (this.bFolded && this.nLevel > 5 && typeof(this.nPreSelected)!= 'number') return (null);
		if (this.oParent) aPos = this.oParent.getChildPosition();
		var aClipp;
		if (this.bFolded)
			aClipp = new Array (0, 0, this.nWidth, this.nElementHeight);
		else
			aClipp = new Array (0, 0, this.nWidth, this.nElementHeight * this.aElements.length);
		return (aPos.concat (aClipp));
	};

/*
	Bestimmt die Position des aktuellen Untermens
*/	
	this.getChildPosition = function() {
		var aPos = [0, 0];
		aPos[0] = this.aLayers[0].get('left') + this.nWidth + this.nChildOffset;
		aPos[1] = (this.bFolded === true || this.bFolded === false ? _aMs[0].aPos[1] : this.aLayers[0].get('top') + this.nSelected * this.nElementHeight);
		return (aPos);
	}
	
	
/*
	Gibt die Position des Elements innerhalb der Geschwister zurueck.
*/
	this.findElementIndex = function (nElementID) {
		if (this.aElements) 
			for (var i=0; i<this.aElements.length; i++)
				if (this.aElements[i][0] == nElementID) return (i);
		return (null);
	}
	
	
/*
	Mouseover
*/	
	this.mo = function (nElem, bOver) {
		if (!_aMs[0].bSuspended) {
			if (bOver) {
				clearTimeout (_aMs[0].oToClose);
				if (this.bFolded) {
					_aMs[0].oToOpen = setTimeout ('_aMs[' + this.nLevel + '].unfold();_aMs[' + this.nLevel + '].nHigh=null;_aMs[' + this.nLevel + '].mo(0,1)', 500);
				}
				else {
					if (this.highlight (nElem) && this.oChild) {
						clearTimeout (this.oToUpdateChild);
						this.oToUpdateChild = setTimeout ('_aMs[' + this.nLevel + '].updateChild(' + nElem + ')', 200);	
						if (this.nSelected == nElem && this.oChild.nSelected != null) this.oChild.highlight (this.oChild.nSelected);
					}
					if (this.oParent && this.oParent.nSelected != null) this.oParent.highlight (this.oParent.nSelected);
				}
			}
			else {
				clearTimeout (_aMs[0].oToOpen);
				if (this.bFolded == null) {
					_aMs[0].oToClose = setTimeout ('_aMs[' + this.nLevel + '].close()', 700);
					this.highlight (null);
				}
				else
					_aMs[0].oToClose = setTimeout ('_aMs[' + this.nLevel + '].fold()', 700);
			}
		}
		window.status = '';
		return (true);
	}	

	
/*
	Verhalten bei Klick auf ein Element	
*/
	this.click = function (nElem) {
		var cPath = (window.getRelativeWebRoot ? window.getRelativeWebRoot() : '');
		var cLangPath = '';
		for (var aLang in CONFIG['ContentLanguages']) if (aLang[2] == LangID) cLangPath = aLang[1];
		cPath += cLangPath + (cLangPath > '' ? '/' : '');
		if (!_aMs[0].bSuspended && nElem < this.aElements.length) {
			var aElement = this.aElements[nElem];
			if (aElement[0] > 0) {
				var cExtension = (window.location.pathname.match (/\.page$/) ? '.page' : '.html');
				var cUrl = cPath + (aElement[4] > '' ? aElement[4] : 'Page' + aElement[0]) + cExtension;
				if (aElement[3]) { // Open in new Window
					var nWinID = Math.round(Math.random() * 10000);
					var oWin = window.open (cUrl, 'Additor' + nWinID, '');
					if (oWin && oWin.focus) oWin.focus();
				}
				else
					window.location = addSID(cUrl);
				_aMs[0].bSuspended = true;
			}
			else if (aElement[0] == 0)
				this.updateChild (nElem);
		}
	}
	
/*
	Kann in getContent() zur Generierung  der Links verwendet werden.
*/	
	this.getLink = function (nElem) {
		var cPath = (window.getRelativeWebRoot ? window.getRelativeWebRoot() : '');
		var cLangPath = '';
		for (var aLang in CONFIG['ContentLanguages']) if (aLang[2] == LangID) cLangPath = aLang[1];
		var cLink = 'href="Javascript:_aMs[' + this.nLevel + '].click(' + nElem + ')"';
		if (nElem < this.aElements.length) {
			var aElement = this.aElements[nElem];
			if (aElement[0] > 0) {
				var cExtension = (window.location.pathname.match (/\.page$/) ? '.page' : '.html');
				if (aElement[4] > '')
					cLink = cPath + aElement[4]
				else
					cLink = 'Page' + aElement[0];
				cLink = 'href="' + addSID(cLink + cExtension) + '"';
				if (aElement[3]) cLink += ' target="_BLANK"';
			}
		}
		return (cLink);
	}
	
/*
	Klappt eine Ebene aus
*/	
	this.fold = function (bUnfold, oCallingMenu) {
		if (this.bFolded != !bUnfold) {
			this.bFolded = !bUnfold;
			if (this.bFolded) {
				if (this.nLevel == 0) 
					this.preset (aMenuEntries);
				else
					this.oParent.fold (bUnfold, this);
			}
			else {
				if (this.oParent) this.oParent.fold (bUnfold, this);
				if (oCallingMenu == null) this.closeChild();
				for (var i=0; i<this.aLayers.length; i++) this.aLayers[i].set ('visibility', false);
				this.aLayers[0].replaceContent (this.getBgContent());
				this.aLayers[1].replaceContent (this.getFgContent());
				this.aLayers[2].replaceContent (this.getMoContent());
				this.updatePosition();
				this.nHigh = null;
				this.highlight (this.nPreSelected);
			}
		}
	};

/*

*/
	this.unfold = function () {
		this.fold (true);
	};
	
	
/*

*/	
	this.preset = function (aMenuEntries) {
		this.aElements = null;
		this.update (aMenuEntries);
		if (this.bFolded) this.highlight (0);
		if (this.oChild && typeof(this.nPreSelected)=='number' && aPagePath.length-1 > this.nLevel && this.nPreSelected < this.aElements.length && this.aElements[this.nPreSelected][2] && this.oChild.bFolded)
			this.oChild.preset (this.aElements[this.nPreSelected][2]);
	}
	

/*
	
*/
	this.update = function (aElements) {
		if (this.aElements != aElements) {
			if (this.oParent) this.bFolded = this.oParent.bFolded;
			if (this.oChild) {
				this.setChildConnector (null);
				this.closeChild();
			}
			this.aElements = aElements;
			this.nPreSelected = null;
			if (!this.oParent || (typeof(this.oParent.nPreSelected)=='number' && (this.oParent.bFolded || this.oParent.nSelected == this.oParent.nPreSelected))) {
				this.nPreSelected = this.findElementIndex (aPagePath[this.nLevel]);
				this.nSelected = this.nPreSelected;
			}
			for (var i=0; i<this.aLayers.length; i++) this.aLayers[i].set ('visibility', false);
			if (this.aElements) {
				this.calculateSize();
				this.aLayers[0].replaceContent (this.getBgContent());
				this.aLayers[1].replaceContent (this.getFgContent());
				this.aLayers[2].replaceContent (this.getMoContent());
				this.updatePosition();
			}
			this.nHigh = null;
		}
	};	

/*
	Holt die Position ber getPosition(), fhrt das Clipping durch, setzt die neue Position
*/
	this.updatePosition = function() {
		var aPos = this.getPosition();
		if (aPos) {
			var aClip = new Array (0, 0, this.nWidth, this.nElementHeight * this.aElements.length);
			if (aPos.length > 2) aClip = aPos.slice (2, 6);
			for (var i=0; i<this.aLayers.length; i++) 
				this.aLayers[i].clipp (aClip[0], aClip[1], (i==1 ? 0 : aClip[2]), aClip[3]);
			for (var i=0; i<this.aLayers.length; i++) {
				this.aLayers[i].moveTo (aPos[0], aPos[1]);
				this.aLayers[i].set ('visibility', true);
			}
		}	
	};
	
	this.calculateSize = function() {
		this.nElementsWidth = this.getElementsWidth();
		this.nWidth = this.nElementsWidth + 15;
	};
	
/*
	Fhrt das Clipping des Highlight-Layers aus
*/
	this.highlight = function (nElem) {
		var bChanged = (nElem != this.nHigh);
		if (bChanged) {
			this.nHigh = nElem;
			if (nElem == null) 
				this.aLayers[1].clipp (0, 0, 0, 0);
			else 
				this.aLayers[1].clipp (0, nElem * this.nElementHeight, this.nWidth, this.nElementHeight);
		}
		return (bChanged);
	};
	
	
/*
	ffnet das Untermen mit den Menpunkten des angegebenen Elements
*/
	this.updateChild = function (nElem) {
		if (this.nHigh == nElem) {
			this.nSelected = nElem;
			var aElements = this.getChildElements (nElem);
			if (this.oChild.bFolded) this.oChild.bFolded = false; 
			this.oChild.update (aElements);
		}
	};
	
/*
	Schliet eine ausgeklappte Unterebene
*/
	this.closeChild = function () {
		this.oChild.update (null);
	};

/*
	Gibt ein Array aller Kinder des Elements nElem zurueck
*/
	this.getChildElements = function (nElem) {
		var aElems = [];
		if (nElem != null) aElems = this.aElements[nElem][2];
		return (aElems); 
	};
	
/*
	Schliet das komplette Men; alle Eltern- und Kind-Mens werden geschlossen
*/
	this.close = function () {
		if (this.aElements) {
			this.update (null);
			if (this.oChild) this.oChild.close();
			if (this.oParent) this.oParent.close();
		}
	};
}

